// GPIOoptions.cpp : implementation file
//

#include "stdafx.h"
#include "GPIO Initialization GUI.h"
#include "GPIOoptions.h"
#include"registers.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// GPIOoptions dialog

GPIOoptions::GPIOoptions(CWnd* pParent /*=NULL*/)
	: CDialog(GPIOoptions::IDD, pParent)
{
	//{{AFX_DATA_INIT(GPIOoptions)
	m_odrain_opt=0;
	m_interrupt_opt=0;
	m_hdrive_opt=0;
	m_iopin_opt=0;
	interrupt_available=TRUE;
	m_smr_opt = 0;
	m_interruptedge = 0;
	//}}AFX_DATA_INIT
	boldfont.CreateFont(16,0,0,0,900,0,0,0,0,0,0,0,0,"Ariel");	
	
}


void GPIOoptions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(GPIOoptions)
	DDX_Control(pDX, IDC_ENL_LABEL, m_ENL_label);
	DDX_Control(pDX, IDC_ENH_LABEL, m_ENH_label);
	DDX_Control(pDX, IDC_ENL7, m_ENL7);
	DDX_Control(pDX, IDC_ENL6, m_ENL6);
	DDX_Control(pDX, IDC_ENL5, m_ENL5);
	DDX_Control(pDX, IDC_ENL4, m_ENL4);
	DDX_Control(pDX, IDC_ENL3, m_ENL3);
	DDX_Control(pDX, IDC_ENL2, m_ENL2);
	DDX_Control(pDX, IDC_ENL1, m_ENL1);
	DDX_Control(pDX, IDC_ENL0, m_ENL0);
	DDX_Control(pDX, IDC_ENH7, m_ENH7);
	DDX_Control(pDX, IDC_ENH6, m_ENH6);
	DDX_Control(pDX, IDC_ENH5, m_ENH5);
	DDX_Control(pDX, IDC_ENH3, m_ENH3);
	DDX_Control(pDX, IDC_ENH4, m_ENH4);
	DDX_Control(pDX, IDC_ENH2, m_ENH2);
	DDX_Control(pDX, IDC_ENH1, m_ENH1);
	DDX_Control(pDX, IDC_ENH0, m_ENH0);
	DDX_Control(pDX, IDC_DD7, m_DD7);
	DDX_Control(pDX, IDC_DD6, m_DD6);
	DDX_Control(pDX, IDC_DD5, m_DD5);
	DDX_Control(pDX, IDC_DD4, m_DD4);
	DDX_Control(pDX, IDC_DD3, m_DD3);
	DDX_Control(pDX, IDC_DD2, m_DD2);
	DDX_Control(pDX, IDC_DD1, m_DD1);
	DDX_Control(pDX, IDC_DD0, m_DD0);
	DDX_Control(pDX, IDC_BIT1, m_BIT1);
	DDX_Control(pDX, IDC_BIT0, m_BIT0);
	DDX_Control(pDX, IDC_SMRE_LABEL, m_smre_label);
	DDX_Control(pDX, IDC_OC_LABEL, m_oc_label);
	DDX_Control(pDX, IDC_IES_LABEL, m_ies_label);
	DDX_Control(pDX, IDC_HDE_LABEL, m_hde_label);
	DDX_Control(pDX, IDC_DD_LABEL, m_dd_label);
	DDX_Control(pDX, IDC_RISEFALLICON, m_risefallicon);
	DDX_Control(pDX, IDC_RISE, m_riseicon);
	DDX_Control(pDX, IDC_FALL, m_fallicon);
	DDX_Control(pDX, IDC_IEDGE7, m_iedge7);
	DDX_Control(pDX, IDC_IEDGE6, m_iedge6);
	DDX_Control(pDX, IDC_IEDGE5, m_iedge5);
	DDX_Control(pDX, IDC_IEDGE4, m_iedge4);
	DDX_Control(pDX, IDC_IEDGE3, m_iedge3);
	DDX_Control(pDX, IDC_IEDGE2, m_iedge2);
	DDX_Control(pDX, IDC_IEDGE1, m_iedge1);
	DDX_Control(pDX, IDC_IEDGE0, m_iedge0);
	DDX_Control(pDX, IDC_LABEL, m_label);
	DDX_Control(pDX, IDC_SMR7, m_SMR7);
	DDX_Control(pDX, IDC_SMR6, m_SMR6);
	DDX_Control(pDX, IDC_SMR5, m_SMR5);
	DDX_Control(pDX, IDC_SMR4, m_SMR4);
	DDX_Control(pDX, IDC_SMR3, m_SMR3);
	DDX_Control(pDX, IDC_SMR2, m_SMR2);
	DDX_Control(pDX, IDC_SMR1, m_SMR1);
	DDX_Control(pDX, IDC_SMR0, m_SMR0);
	DDX_Control(pDX, IDC_OC7, m_OC7);
	DDX_Control(pDX, IDC_OC6, m_OC6);
	DDX_Control(pDX, IDC_OC5, m_OC5);
	DDX_Control(pDX, IDC_OC4, m_OC4);
	DDX_Control(pDX, IDC_OC3, m_OC3);
	DDX_Control(pDX, IDC_OC2, m_OC2);
	DDX_Control(pDX, IDC_OC1, m_OC1);
	DDX_Control(pDX, IDC_OC0, m_OC0);
	DDX_Control(pDX, IDC_HD7, m_HD7);
	DDX_Control(pDX, IDC_HD6, m_HD6);
	DDX_Control(pDX, IDC_HD5, m_HD5);
	DDX_Control(pDX, IDC_HD4, m_HD4);
	DDX_Control(pDX, IDC_HD3, m_HD3);
	DDX_Control(pDX, IDC_HD2, m_HD2);
	DDX_Control(pDX, IDC_HD1, m_HD1);
	DDX_Control(pDX, IDC_HD0, m_HD0);
	DDX_CBIndex(pDX, IDC_COMBO_ODRAIN, m_odrain_opt);
	DDX_CBIndex(pDX, IDC_COMBO_INTERRUPT, m_interrupt_opt);
	DDX_CBIndex(pDX, IDC_COMBO_HDRIVE, m_hdrive_opt);
	DDX_CBIndex(pDX, IDC_COMBO_PIN, m_iopin_opt);
	DDX_CBIndex(pDX, IDC_COMBO_SMR, m_smr_opt);
	DDX_CBIndex(pDX, IDC_RISEFALL, m_interruptedge);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(GPIOoptions, CDialog)
	//{{AFX_MSG_MAP(GPIOoptions)
	ON_CBN_SELCHANGE(IDC_COMBO_PIN, OnSelchangeComboPin)
	ON_BN_CLICKED(IDC_BUTTON_OK, OnButtonOk)
	ON_CBN_SELCHANGE(IDC_COMBO_SMR, OnSelchangeComboSmr)
	ON_CBN_SELCHANGE(IDC_COMBO_ODRAIN, OnSelchangeComboOdrain)
	ON_CBN_SELCHANGE(IDC_COMBO_HDRIVE, OnSelchangeComboHdrive)
	ON_CBN_SELCHANGE(IDC_COMBO_INTERRUPT, OnSelchangeComboInterrupt)
	ON_CBN_SELCHANGE(IDC_RISEFALL, OnSelchangeRisefall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// GPIOoptions message handlers

BOOL GPIOoptions::OnInitDialog() 
{
	CDialog::OnInitDialog();
	// TODO: Add extra initialization here
	UpdateData(FALSE);
	if(m_iopin_opt==0)
	{
	GetDlgItem(IDC_COMBO_ODRAIN)->EnableWindow(FALSE);
	GetDlgItem(IDC_COMBO_HDRIVE)->EnableWindow(FALSE);
	GetDlgItem(IDC_COMBO_INTERRUPT)->EnableWindow(TRUE);
	GetDlgItem(IDC_COMBO_SMR)->EnableWindow(TRUE);
	if(!interrupt_available)//disable the interrupt option if interrupt is not available for the port.
		GetDlgItem(IDC_COMBO_INTERRUPT)->EnableWindow(FALSE);
	}
	else
	{
	GetDlgItem(IDC_COMBO_ODRAIN)->EnableWindow(TRUE);
	GetDlgItem(IDC_COMBO_HDRIVE)->EnableWindow(TRUE);
	GetDlgItem(IDC_COMBO_INTERRUPT)->EnableWindow(FALSE);
	GetDlgItem(IDC_COMBO_SMR)->EnableWindow(FALSE);
	}
	CString label;
	label.Format("Port %c Pin %d",port,Pin_No);//setting the appropriate label values for the pin  config dialog
	m_label.SetWindowText(label);	
	m_label.SetFont(&boldfont);
	label.Format("P%cDD [7:0]",port);
	m_dd_label.SetWindowText(label);
	label.Format("P%cOC [7:0]",port);
	m_oc_label.SetWindowText(label);
	label.Format("P%cHDE [7:0]",port);
	m_hde_label.SetWindowText(label);
	label.Format("P%cSMRE [7:0]",port);
	m_smre_label.SetWindowText(label);
	label.Format("P%c%dENH",port,Pin_No);
	m_ENH_label.SetWindowText(label);
	label.Format("P%c%dENL",port,Pin_No);
	m_ENL_label.SetWindowText(label);
	label.Format("IES%d",Pin_No);
	m_ies_label.SetWindowText(label);


	riseicon=m_riseicon.GetIcon();
	fallicon=m_fallicon.GetIcon();
	bit0=m_BIT0.GetBitmap();
	bit1=m_BIT1.GetBitmap();
	
	if( m_interruptedge==1)
		m_risefallicon.SetIcon(riseicon);
	else
		m_risefallicon.SetIcon(fallicon);

	switch(port)
	{
	case 'A':
		RefreshPADD();
		RefreshPAOC();
		RefreshPAHDE();
		RefreshPASMRE();
		RefreshPAEN();
		RefreshPAIES();
	break;

	case 'B':
		RefreshPBDD();
		RefreshPBOC();
		RefreshPBHDE();
		RefreshPBSMRE();
		GetDlgItem(IDC_RISEFALL)->EnableWindow(FALSE);
	break;

	case 'C':
		RefreshPCDD();
		RefreshPCOC();
		RefreshPCHDE();
		RefreshPCSMRE();
		RefreshPCEN();
		GetDlgItem(IDC_RISEFALL)->EnableWindow(FALSE);
	break;
	}


	return TRUE;  // return TRUE unless you set the focus to a control
              // EXCEPTION: OCX Property Pages should return FALSE
	

}

void GPIOoptions::OnSelchangeComboPin() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	
	if(m_iopin_opt==0)
	{
	GetDlgItem(IDC_COMBO_ODRAIN)->EnableWindow(FALSE);
	GetDlgItem(IDC_COMBO_HDRIVE)->EnableWindow(FALSE);
	GetDlgItem(IDC_COMBO_INTERRUPT)->EnableWindow(TRUE);
	GetDlgItem(IDC_COMBO_SMR)->EnableWindow(TRUE);

	m_hdrive_opt=0;//reset values of disabled items
	m_odrain_opt=0;
	UpdateData(FALSE);
	OnSelchangeComboOdrain();
	OnSelchangeComboHdrive();
	
	if(!interrupt_available)//disable the interrupt option if interrupt is not available for the port.
		GetDlgItem(IDC_COMBO_INTERRUPT)->EnableWindow(FALSE);
	}
	else
	{
	GetDlgItem(IDC_COMBO_ODRAIN)->EnableWindow(TRUE);
	GetDlgItem(IDC_COMBO_HDRIVE)->EnableWindow(TRUE);
	GetDlgItem(IDC_COMBO_INTERRUPT)->EnableWindow(FALSE);
	GetDlgItem(IDC_COMBO_SMR)->EnableWindow(FALSE);
	
	m_interrupt_opt=0;//reset values of disabled items
	m_smr_opt=0;
	m_interruptedge=0;
	UpdateData(FALSE);
	OnSelchangeComboSmr();
	OnSelchangeComboInterrupt();
	}
	int temp=1<<Pin_No;
	switch(port)
	{
	case 'A':
		PortA.DD&=~temp;//switch off the bit	
		PortA.DD|=(!m_iopin_opt)<<Pin_No;//switch on/off depending on the option selected
		RefreshPADD();
		break;
	case 'B':
		PortB.DD&=~temp;//switch off the bit	
		PortB.DD|=(!m_iopin_opt)<<Pin_No;//switch on/off depending on the option selected
		RefreshPBDD();
		break;
	case 'C':
		PortC.DD&=~temp;//switch off the bit	
		PortC.DD|=(!m_iopin_opt)<<Pin_No;//switch on/off depending on the option selected
		RefreshPCDD();
		break;
	}

}

void GPIOoptions::OnButtonOk() 
{
	// TODO: Add your control notification handler code here
	OnOK();
}



void GPIOoptions::RefreshPADD()
{
		PortA.DD&1? m_DD0.SetBitmap(bit1):m_DD0.SetBitmap(bit0);	
		PortA.DD&2? m_DD1.SetBitmap(bit1):m_DD1.SetBitmap(bit0);	
		PortA.DD&4? m_DD2.SetBitmap(bit1):m_DD2.SetBitmap(bit0);	
		PortA.DD&8? m_DD3.SetBitmap(bit1):m_DD3.SetBitmap(bit0);	
		PortA.DD&16? m_DD4.SetBitmap(bit1):m_DD4.SetBitmap(bit0);
		PortA.DD&32? m_DD5.SetBitmap(bit1):m_DD5.SetBitmap(bit0);
		PortA.DD&64? m_DD6.SetBitmap(bit1):m_DD6.SetBitmap(bit0);
		PortA.DD&128? m_DD7.SetBitmap(bit1):m_DD7.SetBitmap(bit0);
				
}


void GPIOoptions::RefreshPAOC()
{
		PortA.OC&1? m_OC0.SetBitmap(bit1):m_OC0.SetBitmap(bit0);	
		PortA.OC&2? m_OC1.SetBitmap(bit1):m_OC1.SetBitmap(bit0);	
		PortA.OC&4? m_OC2.SetBitmap(bit1):m_OC2.SetBitmap(bit0);	
		PortA.OC&8? m_OC3.SetBitmap(bit1):m_OC3.SetBitmap(bit0);	
		PortA.OC&16? m_OC4.SetBitmap(bit1):m_OC4.SetBitmap(bit0);	
		PortA.OC&32? m_OC5.SetBitmap(bit1):m_OC5.SetBitmap(bit0);	
		PortA.OC&64? m_OC6.SetBitmap(bit1):m_OC6.SetBitmap(bit0);	
		PortA.OC&128? m_OC7.SetBitmap(bit1):m_OC7.SetBitmap(bit0);	
}

void GPIOoptions::RefreshPAHDE()
{
		PortA.HDE&1? m_HD0.SetBitmap(bit1):m_HD0.SetBitmap(bit0);	
		PortA.HDE&2? m_HD1.SetBitmap(bit1):m_HD1.SetBitmap(bit0);	
		PortA.HDE&4? m_HD2.SetBitmap(bit1):m_HD2.SetBitmap(bit0);	
		PortA.HDE&8? m_HD3.SetBitmap(bit1):m_HD3.SetBitmap(bit0);	
		PortA.HDE&16? m_HD4.SetBitmap(bit1):m_HD4.SetBitmap(bit0);	
		PortA.HDE&32? m_HD5.SetBitmap(bit1):m_HD5.SetBitmap(bit0);	
		PortA.HDE&64? m_HD6.SetBitmap(bit1):m_HD6.SetBitmap(bit0);	
		PortA.HDE&128? m_HD7.SetBitmap(bit1):m_HD7.SetBitmap(bit0);	
}

void GPIOoptions::RefreshPASMRE()
{
		PortA.SMR&1? m_SMR0.SetBitmap(bit1):m_SMR0.SetBitmap(bit0);
		PortA.SMR&2? m_SMR1.SetBitmap(bit1):m_SMR1.SetBitmap(bit0);
		PortA.SMR&4? m_SMR2.SetBitmap(bit1):m_SMR2.SetBitmap(bit0);
		PortA.SMR&8? m_SMR3.SetBitmap(bit1):m_SMR3.SetBitmap(bit0);
		PortA.SMR&16? m_SMR4.SetBitmap(bit1):m_SMR4.SetBitmap(bit0);
		PortA.SMR&32? m_SMR5.SetBitmap(bit1):m_SMR5.SetBitmap(bit0);
		PortA.SMR&64? m_SMR6.SetBitmap(bit1):m_SMR6.SetBitmap(bit0);
		PortA.SMR&128? m_SMR7.SetBitmap(bit1):m_SMR7.SetBitmap(bit0);
}


void GPIOoptions::RefreshPBDD()
{
		PortB.DD&1? m_DD0.SetBitmap(bit1):m_DD0.SetBitmap(bit0);	
		PortB.DD&2? m_DD1.SetBitmap(bit1):m_DD1.SetBitmap(bit0);	
		PortB.DD&4? m_DD2.SetBitmap(bit1):m_DD2.SetBitmap(bit0);	
		PortB.DD&8? m_DD3.SetBitmap(bit1):m_DD3.SetBitmap(bit0);	
		PortB.DD&16? m_DD4.SetBitmap(bit1):m_DD4.SetBitmap(bit0);
		PortB.DD&32? m_DD5.SetBitmap(bit1):m_DD5.SetBitmap(bit0);
		PortB.DD&64? m_DD6.SetBitmap(bit1):m_DD6.SetBitmap(bit0);
		PortB.DD&128? m_DD7.SetBitmap(bit1):m_DD7.SetBitmap(bit0);
				
}



void GPIOoptions::RefreshPBOC()
{
		PortB.OC&1? m_OC0.SetBitmap(bit1):m_OC0.SetBitmap(bit0);	
		PortB.OC&2? m_OC1.SetBitmap(bit1):m_OC1.SetBitmap(bit0);	
		PortB.OC&4? m_OC2.SetBitmap(bit1):m_OC2.SetBitmap(bit0);	
		PortB.OC&8? m_OC3.SetBitmap(bit1):m_OC3.SetBitmap(bit0);	
		PortB.OC&16? m_OC4.SetBitmap(bit1):m_OC4.SetBitmap(bit0);	
		PortB.OC&32? m_OC5.SetBitmap(bit1):m_OC5.SetBitmap(bit0);	
		PortB.OC&64? m_OC6.SetBitmap(bit1):m_OC6.SetBitmap(bit0);	
		PortB.OC&128? m_OC7.SetBitmap(bit1):m_OC7.SetBitmap(bit0);	
}

void GPIOoptions::RefreshPBHDE()
{
		PortB.HDE&1? m_HD0.SetBitmap(bit1):m_HD0.SetBitmap(bit0);	
		PortB.HDE&2? m_HD1.SetBitmap(bit1):m_HD1.SetBitmap(bit0);	
		PortB.HDE&4? m_HD2.SetBitmap(bit1):m_HD2.SetBitmap(bit0);	
		PortB.HDE&8? m_HD3.SetBitmap(bit1):m_HD3.SetBitmap(bit0);	
		PortB.HDE&16? m_HD4.SetBitmap(bit1):m_HD4.SetBitmap(bit0);	
		PortB.HDE&32? m_HD5.SetBitmap(bit1):m_HD5.SetBitmap(bit0);	
		PortB.HDE&64? m_HD6.SetBitmap(bit1):m_HD6.SetBitmap(bit0);	
		PortB.HDE&128? m_HD7.SetBitmap(bit1):m_HD7.SetBitmap(bit0);	
}

void GPIOoptions::RefreshPBSMRE()
{
		PortB.SMR&1? m_SMR0.SetBitmap(bit1):m_SMR0.SetBitmap(bit0);
		PortB.SMR&2? m_SMR1.SetBitmap(bit1):m_SMR1.SetBitmap(bit0);
		PortB.SMR&4? m_SMR2.SetBitmap(bit1):m_SMR2.SetBitmap(bit0);
		PortB.SMR&8? m_SMR3.SetBitmap(bit1):m_SMR3.SetBitmap(bit0);
		PortB.SMR&16? m_SMR4.SetBitmap(bit1):m_SMR4.SetBitmap(bit0);
		PortB.SMR&32? m_SMR5.SetBitmap(bit1):m_SMR5.SetBitmap(bit0);
		PortB.SMR&64? m_SMR6.SetBitmap(bit1):m_SMR6.SetBitmap(bit0);
		PortB.SMR&128? m_SMR7.SetBitmap(bit1):m_SMR7.SetBitmap(bit0);
}

void GPIOoptions::RefreshPCDD()
{
		PortC.DD&1? m_DD0.SetBitmap(bit1):m_DD0.SetBitmap(bit0);	
		PortC.DD&2? m_DD1.SetBitmap(bit1):m_DD1.SetBitmap(bit0);	
		PortC.DD&4? m_DD2.SetBitmap(bit1):m_DD2.SetBitmap(bit0);	
		PortC.DD&8? m_DD3.SetBitmap(bit1):m_DD3.SetBitmap(bit0);	
		PortC.DD&16? m_DD4.SetBitmap(bit1):m_DD4.SetBitmap(bit0);
		PortC.DD&32? m_DD5.SetBitmap(bit1):m_DD5.SetBitmap(bit0);
		PortC.DD&64? m_DD6.SetBitmap(bit1):m_DD6.SetBitmap(bit0);
		PortC.DD&128? m_DD7.SetBitmap(bit1):m_DD7.SetBitmap(bit0);
				
}

void GPIOoptions::RefreshPCOC()
{
		PortC.OC&1? m_OC0.SetBitmap(bit1):m_OC0.SetBitmap(bit0);	
		PortC.OC&2? m_OC1.SetBitmap(bit1):m_OC1.SetBitmap(bit0);	
		PortC.OC&4? m_OC2.SetBitmap(bit1):m_OC2.SetBitmap(bit0);	
		PortC.OC&8? m_OC3.SetBitmap(bit1):m_OC3.SetBitmap(bit0);	
		PortC.OC&16? m_OC4.SetBitmap(bit1):m_OC4.SetBitmap(bit0);	
		PortC.OC&32? m_OC5.SetBitmap(bit1):m_OC5.SetBitmap(bit0);	
		PortC.OC&64? m_OC6.SetBitmap(bit1):m_OC6.SetBitmap(bit0);	
		PortC.OC&128? m_OC7.SetBitmap(bit1):m_OC7.SetBitmap(bit0);	
}

void GPIOoptions::RefreshPCHDE()
{
		PortC.HDE&1? m_HD0.SetBitmap(bit1):m_HD0.SetBitmap(bit0);	
		PortC.HDE&2? m_HD1.SetBitmap(bit1):m_HD1.SetBitmap(bit0);	
		PortC.HDE&4? m_HD2.SetBitmap(bit1):m_HD2.SetBitmap(bit0);	
		PortC.HDE&8? m_HD3.SetBitmap(bit1):m_HD3.SetBitmap(bit0);	
		PortC.HDE&16? m_HD4.SetBitmap(bit1):m_HD4.SetBitmap(bit0);	
		PortC.HDE&32? m_HD5.SetBitmap(bit1):m_HD5.SetBitmap(bit0);	
		PortC.HDE&64? m_HD6.SetBitmap(bit1):m_HD6.SetBitmap(bit0);	
		PortC.HDE&128? m_HD7.SetBitmap(bit1):m_HD7.SetBitmap(bit0);	
}

void GPIOoptions::RefreshPCSMRE()
{
		PortC.SMR&1? m_SMR0.SetBitmap(bit1):m_SMR0.SetBitmap(bit0);
		PortC.SMR&2? m_SMR1.SetBitmap(bit1):m_SMR1.SetBitmap(bit0);
		PortC.SMR&4? m_SMR2.SetBitmap(bit1):m_SMR2.SetBitmap(bit0);
		PortC.SMR&8? m_SMR3.SetBitmap(bit1):m_SMR3.SetBitmap(bit0);
		PortC.SMR&16? m_SMR4.SetBitmap(bit1):m_SMR4.SetBitmap(bit0);
		PortC.SMR&32? m_SMR5.SetBitmap(bit1):m_SMR5.SetBitmap(bit0);
		PortC.SMR&64? m_SMR6.SetBitmap(bit1):m_SMR6.SetBitmap(bit0);
		PortC.SMR&128? m_SMR7.SetBitmap(bit1):m_SMR7.SetBitmap(bit0);
}

void GPIOoptions::RefreshPAEN()
{
		if(m_interrupt_opt)
		GetDlgItem(IDC_RISEFALL)->EnableWindow(TRUE);
		else
		GetDlgItem(IDC_RISEFALL)->EnableWindow(FALSE);

		registers::IRQ1ENH&1? m_ENH0.SetBitmap(bit1):m_ENH0.SetBitmap(bit0);
		registers::IRQ1ENH&2? m_ENH1.SetBitmap(bit1):m_ENH1.SetBitmap(bit0);
		registers::IRQ1ENH&4? m_ENH2.SetBitmap(bit1):m_ENH2.SetBitmap(bit0);
		registers::IRQ1ENH&8? m_ENH3.SetBitmap(bit1):m_ENH3.SetBitmap(bit0);
		registers::IRQ1ENH&16? m_ENH4.SetBitmap(bit1):m_ENH4.SetBitmap(bit0);
		registers::IRQ1ENH&32? m_ENH5.SetBitmap(bit1):m_ENH5.SetBitmap(bit0);
		registers::IRQ1ENH&64? m_ENH6.SetBitmap(bit1):m_ENH6.SetBitmap(bit0);
		registers::IRQ1ENH&128? m_ENH7.SetBitmap(bit1):m_ENH7.SetBitmap(bit0);

		registers::IRQ1ENL&1? m_ENL0.SetBitmap(bit1):m_ENL0.SetBitmap(bit0);
		registers::IRQ1ENL&2? m_ENL1.SetBitmap(bit1):m_ENL1.SetBitmap(bit0);
		registers::IRQ1ENL&4? m_ENL2.SetBitmap(bit1):m_ENL2.SetBitmap(bit0);
		registers::IRQ1ENL&8? m_ENL3.SetBitmap(bit1):m_ENL3.SetBitmap(bit0);
		registers::IRQ1ENL&16? m_ENL4.SetBitmap(bit1):m_ENL4.SetBitmap(bit0);
		registers::IRQ1ENL&32? m_ENL5.SetBitmap(bit1):m_ENL5.SetBitmap(bit0);
		registers::IRQ1ENL&64? m_ENL6.SetBitmap(bit1):m_ENL6.SetBitmap(bit0);
		registers::IRQ1ENL&128? m_ENL7.SetBitmap(bit1):m_ENL7.SetBitmap(bit0);
}

void GPIOoptions::RefreshPCEN()
{
		registers::IRQ2ENH&1? m_ENH0.SetBitmap(bit1):m_ENH0.SetBitmap(bit0);
		registers::IRQ2ENH&2? m_ENH1.SetBitmap(bit1):m_ENH1.SetBitmap(bit0);
		registers::IRQ2ENH&4? m_ENH2.SetBitmap(bit1):m_ENH2.SetBitmap(bit0);
		registers::IRQ2ENH&8? m_ENH3.SetBitmap(bit1):m_ENH3.SetBitmap(bit0);
		registers::IRQ2ENH&16? m_ENH4.SetBitmap(bit1):m_ENH4.SetBitmap(bit0);
		registers::IRQ2ENH&32? m_ENH5.SetBitmap(bit1):m_ENH5.SetBitmap(bit0);
		registers::IRQ2ENH&64? m_ENH6.SetBitmap(bit1):m_ENH6.SetBitmap(bit0);
		registers::IRQ2ENH&128? m_ENH7.SetBitmap(bit1):m_ENH7.SetBitmap(bit0);

		registers::IRQ2ENL&1? m_ENL0.SetBitmap(bit1):m_ENL0.SetBitmap(bit0);
		registers::IRQ2ENL&2? m_ENL1.SetBitmap(bit1):m_ENL1.SetBitmap(bit0);
		registers::IRQ2ENL&4? m_ENL2.SetBitmap(bit1):m_ENL2.SetBitmap(bit0);
		registers::IRQ2ENL&8? m_ENL3.SetBitmap(bit1):m_ENL3.SetBitmap(bit0);
		registers::IRQ2ENL&16? m_ENL4.SetBitmap(bit1):m_ENL4.SetBitmap(bit0);
		registers::IRQ2ENL&32? m_ENL5.SetBitmap(bit1):m_ENL5.SetBitmap(bit0);
		registers::IRQ2ENL&64? m_ENL6.SetBitmap(bit1):m_ENL6.SetBitmap(bit0);
		registers::IRQ2ENL&128? m_ENL7.SetBitmap(bit1):m_ENL7.SetBitmap(bit0);
}

void GPIOoptions::RefreshPAIES()
{
		if(m_interruptedge==0)
			m_risefallicon.SetIcon(fallicon);
		else
			m_risefallicon.SetIcon(riseicon);

		registers::IRQES&1? m_iedge0.SetBitmap(bit1):m_iedge0.SetBitmap(bit0);	
		registers::IRQES&2? m_iedge1.SetBitmap(bit1):m_iedge1.SetBitmap(bit0);	
		registers::IRQES&4? m_iedge2.SetBitmap(bit1):m_iedge2.SetBitmap(bit0);	
		registers::IRQES&8? m_iedge3.SetBitmap(bit1):m_iedge3.SetBitmap(bit0);	
		registers::IRQES&16? m_iedge4.SetBitmap(bit1):m_iedge4.SetBitmap(bit0);	
		registers::IRQES&32? m_iedge5.SetBitmap(bit1):m_iedge5.SetBitmap(bit0);	
		registers::IRQES&64? m_iedge6.SetBitmap(bit1):m_iedge6.SetBitmap(bit0);	
		registers::IRQES&128? m_iedge7.SetBitmap(bit1):m_iedge7.SetBitmap(bit0);	
}

void GPIOoptions::OnSelchangeComboSmr() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int temp=1<<Pin_No;
	switch(port)
	{
	case 'A':
		PortA.SMR&=~temp;//switch off the bit	
		PortA.SMR|=m_smr_opt<<Pin_No;//switch on/off depending on the option selected
		RefreshPASMRE();
		break;
	case 'B':
		PortB.SMR&=~temp;//switch off the bit	
		PortB.SMR|=m_smr_opt<<Pin_No;//switch on/off depending on the option selected
		RefreshPBSMRE();
		break;
	case 'C':
		PortC.SMR&=~temp;//switch off the bit	
		PortC.SMR|=m_smr_opt<<Pin_No;//switch on/off depending on the option selected
		RefreshPCSMRE();
		break;
	}	

}

void GPIOoptions::OnSelchangeComboOdrain() 
{
	// TODO: Add your control notification handler code here

	UpdateData(TRUE);
	int temp=1<<Pin_No;
	switch(port)
	{
	case 'A':
		PortA.OC&=~temp;//switch off the bit	
		PortA.OC|=m_odrain_opt<<Pin_No;//switch on/off depending on the option selected
		RefreshPAOC();
		break;
	case 'B':
		PortB.OC&=~temp;//switch off the bit	
		PortB.OC|=m_odrain_opt<<Pin_No;//switch on/off depending on the option selected
		RefreshPBOC();
		break;
	case 'C':
		PortC.OC&=~temp;//switch off the bit	
		PortC.OC|=m_odrain_opt<<Pin_No;//switch on/off depending on the option selected
		RefreshPCOC();
		break;
	}	
	
}

void GPIOoptions::OnSelchangeComboHdrive() 
{
	// TODO: Add your control notification handler code here

	UpdateData(TRUE);
	int temp=1<<Pin_No;
	switch(port)
	{
	case 'A':
		PortA.HDE&=~temp;//switch off the bit	
		PortA.HDE|=m_hdrive_opt<<Pin_No;//switch on/off depending on the option selected
		RefreshPAHDE();
		break;
	case 'B':
		PortB.HDE&=~temp;//switch off the bit	
		PortB.HDE|=m_hdrive_opt<<Pin_No;//switch on/off depending on the option selected
		RefreshPBHDE();
		break;
	case 'C':
		PortC.HDE&=~temp;//switch off the bit	
		PortC.HDE|=m_hdrive_opt<<Pin_No;//switch on/off depending on the option selected
		RefreshPCHDE();
		break;
	}	
		
}

void GPIOoptions::OnSelchangeComboInterrupt() 
{
	// TODO: Add your control notification handler code here
	
	UpdateData(TRUE);
	int temp=1<<Pin_No;
	switch(port)
	{
	case 'A':
		registers::IRQ1ENH&=~temp;//switch off the bit	
		registers::IRQ1ENL&=~temp;
		if(m_interrupt_opt&1)
		registers::IRQ1ENL|=temp;//switch on
		if(m_interrupt_opt&2)
		registers::IRQ1ENH|=temp;//switch on
		
		if(m_interrupt_opt==0)//if interrupt is Disabled, Disable the Interrupt Edge select Register
			{
			registers::IRQES&=~temp;
			}
		RefreshPAEN();
		RefreshPAIES();
		break;

	case 'C':
		registers::IRQ2ENH&=~temp;//switch off the bit	
		registers::IRQ2ENL&=~temp;
		if(m_interrupt_opt&1)
			registers::IRQ2ENL|=temp;//switch on
		if(m_interrupt_opt&2)
			registers::IRQ2ENH|=temp;//switch on
		RefreshPCEN();
		break;
	}	



}

void GPIOoptions::OnSelchangeRisefall() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	int temp=1<<Pin_No;
	switch(port)
	{
	case 'A':
		registers::IRQES&=~temp;//switch off the bit	
		registers::IRQES|=m_interruptedge<<Pin_No;//switch on/off depending on the option selected
		RefreshPAIES();
		break;
	}	
	
}

sub_registers GPIOoptions::PortA;
sub_registers GPIOoptions::PortB;
sub_registers GPIOoptions::PortC;
void GPIOoptions::OnCancel() 
{
	// TODO: Add extra cleanup here
	m_iopin_opt=0;
	m_interrupt_opt=0;//reset values
	m_smr_opt=0;
	m_interruptedge=0;
	m_hdrive_opt=0;
	m_odrain_opt=0;
	UpdateData(FALSE);
	OnSelchangeComboPin();
	OnSelchangeComboSmr();
	OnSelchangeComboInterrupt();
	OnSelchangeComboOdrain();
	OnSelchangeComboHdrive();
	CDialog::OnCancel();
}
