#if !defined(AFX_GPIOOPTIONS_H__3721783E_251C_4D6E_85B7_C661CFCD05BB__INCLUDED_)
#define AFX_GPIOOPTIONS_H__3721783E_251C_4D6E_85B7_C661CFCD05BB__INCLUDED_
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GPIOoptions.h : header file
//



class sub_registers//The sub registers class definition
{
public:
	unsigned char DD;
	unsigned char OC;
	unsigned char HDE;
	unsigned char SMR;
sub_registers()
{
	DD=0xff;
	OC=HDE=SMR=0;
}

void Reset()
{
	DD=0xff;
	OC=HDE=SMR=0;
}

};


/////////////////////////////////////////////////////////////////////////////
// GPIOoptions dialog

class GPIOoptions : public CDialog
{

	void RefreshPADD();
	void RefreshPASMRE();
	void RefreshPAHDE();
	void RefreshPAOC();
	void RefreshPAEN();
	void RefreshPAIES();

	void RefreshPBDD();
	void RefreshPBSMRE();
	void RefreshPBHDE();
	void RefreshPBOC();

	void RefreshPCDD();
	void RefreshPCSMRE();
	void RefreshPCHDE();
	void RefreshPCOC();
	void RefreshPCEN();
public:	
	static sub_registers PortA;//Ports Subregisters
	static sub_registers PortB;
	static sub_registers PortC;

	static void RESET(void)//Reset all the pins
	{
		PortA.Reset();
		PortB.Reset();
		PortC.Reset();
	}
	CFont boldfont;
	HICON riseicon,fallicon;
	HBITMAP bit0,bit1;
// Construction
	GPIOoptions(CWnd* pParent = NULL);   // standard constructor
// Dialog Data
	//{{AFX_DATA(GPIOoptions)
	enum { IDD = IDD_GPIO_OPTIONS };
	CStatic	m_ENL_label;
	CStatic	m_ENH_label;
	CStatic	m_ENL7;
	CStatic	m_ENL6;
	CStatic	m_ENL5;
	CStatic	m_ENL4;
	CStatic	m_ENL3;
	CStatic	m_ENL2;
	CStatic	m_ENL1;
	CStatic	m_ENL0;
	CStatic	m_ENH7;
	CStatic	m_ENH6;
	CStatic	m_ENH5;
	CStatic	m_ENH3;
	CStatic	m_ENH4;
	CStatic	m_ENH2;
	CStatic	m_ENH1;
	CStatic	m_ENH0;
	CStatic	m_DD7;
	CStatic	m_DD6;
	CStatic	m_DD5;
	CStatic	m_DD4;
	CStatic	m_DD3;
	CStatic	m_DD2;
	CStatic	m_DD1;
	CStatic	m_DD0;
	CStatic	m_BIT1;
	CStatic	m_BIT0;
	CStatic	m_smre_label;
	CStatic	m_oc_label;
	CStatic	m_ies_label;
	CStatic	m_hde_label;
	CStatic	m_enl_label;
	CStatic	m_enh_label;
	CStatic	m_dd_label;
	CStatic	m_risefallicon;
	CStatic	m_riseicon;
	CStatic	m_fallicon;
	CStatic	m_iedge7;
	CStatic	m_iedge6;
	CStatic	m_iedge5;
	CStatic	m_iedge4;
	CStatic	m_iedge3;
	CStatic	m_iedge2;
	CStatic	m_iedge1;
	CStatic	m_iedge0;
	CStatic	m_label;
	CStatic	m_SMR7;
	CStatic	m_SMR6;
	CStatic	m_SMR5;
	CStatic	m_SMR4;
	CStatic	m_SMR3;
	CStatic	m_SMR2;
	CStatic	m_SMR1;
	CStatic	m_SMR0;
	CStatic	m_OC7;
	CStatic	m_OC6;
	CStatic	m_OC5;
	CStatic	m_OC4;
	CStatic	m_OC3;
	CStatic	m_OC2;
	CStatic	m_OC1;
	CStatic	m_OC0;
	CStatic	m_HD7;
	CStatic	m_HD6;
	CStatic	m_HD5;
	CStatic	m_HD4;
	CStatic	m_HD3;
	CStatic	m_HD2;
	CStatic	m_HD1;
	CStatic	m_HD0;
	int		m_odrain_opt;
	int		m_interrupt_opt;
	int		m_hdrive_opt;
	int		m_iopin_opt;
	int Pin_No;
	char port;
	bool interrupt_available;	
	int		m_smr_opt;
	int		m_interruptedge;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(GPIOoptions)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(GPIOoptions)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeComboPin();
	afx_msg void OnButtonOk();
	afx_msg void OnSelchangeComboSmr();
	afx_msg void OnSelchangeComboOdrain();
	afx_msg void OnSelchangeComboHdrive();
	afx_msg void OnSelchangeComboInterrupt();
	afx_msg void OnSelchangeRisefall();
	virtual void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GPIOOPTIONS_H__3721783E_251C_4D6E_85B7_C661CFCD05BB__INCLUDED_)
