// Timer_input.cpp : implementation file
//

#include "stdafx.h"
#include "GPIO Initialization GUI.h"
#include "GPIO Initialization GUIDlg.h"
#include "Timer_input.h"
#include "registers.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Timer_input dialog
Timer_input::Timer_input(CWnd* pParent /*=NULL*/)
	: CDialog(Timer_input::IDD, pParent)
{
	//{{AFX_DATA_INIT(Timer_input)
	m_tmode=0;
	m_prescale=0;
	m_interrupt_opt=0;
	m_tpol = 0;
	PWMH = 0;
	PWML = 0;
	RH = 0xff;
	RL = 0xff;
	TL = 1;
	TH = 0;
	//}}AFX_DATA_INIT
	boldfont.CreateFont(16,0,0,0,900,0,0,0,0,0,0,0,0,"Ariel");	
}


void Timer_input::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Timer_input)
	DDX_Control(pDX, IDC_BIT1, m_BIT1);
	DDX_Control(pDX, IDC_BIT0, m_BIT0);
	DDX_Control(pDX, IDC_IRQ0ENL7, m_irq0enl7);
	DDX_Control(pDX, IDC_IRQ0ENL6, m_irq0enl6);
	DDX_Control(pDX, IDC_IRQ0ENL5, m_irq0enl5);
	DDX_Control(pDX, IDC_IRQ0ENL4, m_irq0enl4);
	DDX_Control(pDX, IDC_IRQ0ENL3, m_irq0enl3);
	DDX_Control(pDX, IDC_IRQ0ENL2, m_irq0enl2);
	DDX_Control(pDX, IDC_IRQ0ENL1, m_irq0enl1);
	DDX_Control(pDX, IDC_IRQ0ENL0, m_irq0enl0);
	DDX_Control(pDX, IDC_IRQ0ENH7, m_irq0enh7);
	DDX_Control(pDX, IDC_IRQ0ENH6, m_irq0enh6);
	DDX_Control(pDX, IDC_IRQ0ENH5, m_irq0enh5);
	DDX_Control(pDX, IDC_IRQ0ENH4, m_irq0enh4);
	DDX_Control(pDX, IDC_IRQ0ENH3, m_irq0enh3);
	DDX_Control(pDX, IDC_IRQ0ENH2, m_irq0enh2);
	DDX_Control(pDX, IDC_IRQ0ENH1, m_irq0enh1);
	DDX_Control(pDX, IDC_IRQ0ENH0, m_irq0enh0);
	DDX_Control(pDX, IDC_TCTL, m_tctl_label);
	DDX_Control(pDX, IDC_TLABEL, m_tlabel);
	DDX_Control(pDX, IDC_TCTL7, m_tctl7);
	DDX_Control(pDX, IDC_TCTL6, m_tctl6);
	DDX_Control(pDX, IDC_TCTL5, m_tctl5);
	DDX_Control(pDX, IDC_TCTL4, m_tctl4);
	DDX_Control(pDX, IDC_TCTL3, m_tctl3);
	DDX_Control(pDX, IDC_TCTL2, m_tctl2);
	DDX_Control(pDX, IDC_TCTL1, m_tctl1);
	DDX_Control(pDX, IDC_TCTL0, m_tctl0);
	DDX_CBIndex(pDX, IDC_MODE, m_tmode);
	DDX_CBIndex(pDX, IDC_PRESCALE, m_prescale);
	DDX_CBIndex(pDX, IDC_COMBO_INTERRUPT, m_interrupt_opt);
	DDX_CBIndex(pDX, IDC_POLARITY, m_tpol);
	DDX_CBIndex(pDX, IDC_PWMH, PWMH);
	DDX_CBIndex(pDX, IDC_PWML, PWML);
	DDX_CBIndex(pDX, IDC_RH, RH);
	DDX_CBIndex(pDX, IDC_RL, RL);
	DDX_CBIndex(pDX, IDC_TL, TL);
	DDX_CBIndex(pDX, IDC_TH, TH);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Timer_input, CDialog)
	//{{AFX_MSG_MAP(Timer_input)
	ON_CBN_SELCHANGE(IDC_MODE, OnSelchangeMode)
	ON_CBN_SELCHANGE(IDC_PRESCALE, OnSelchangePrescale)
	ON_CBN_SELCHANGE(IDC_POLARITY, OnSelchangePolarity)
	ON_CBN_SELCHANGE(IDC_COMBO_INTERRUPT, OnSelchangeComboInterrupt)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Timer_input message handlers

BOOL Timer_input::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	UpdateData(FALSE);
	bit0=m_BIT0.GetBitmap();
	bit1=m_BIT1.GetBitmap();
	
	m_tlabel.SetFont(&boldfont);
	CString label;
	label.Format("Timer %d Input",tnum);
	m_tlabel.SetWindowText(label);
	label.Format("T%dCTL[7:0]",tnum);
	m_tctl_label.SetWindowText(label);

	RefreshIRQ0ENH();
	RefreshIRQ0ENL();

	if(m_tmode!=3)
	{
	GetDlgItem(IDC_PWMH)->EnableWindow(FALSE);
	GetDlgItem(IDC_PWML)->EnableWindow(FALSE);
	}
	
	switch(tnum)
	{
	case 0:	RefreshT0CTL();
		break;
	case 1:	RefreshT1CTL();
		break;
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void Timer_input::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);
	CDialog::OnOK();
}

void Timer_input::OnSelchangeMode() 
{
	// TODO: Add your control notification handler code here
UpdateData(TRUE);
	switch(tnum)
	{
	case 0:
	registers::T0CTL&=0xf8;//switch off the first three bits(tmode field) in registers::T0CTL.
	registers::T0CTL|=m_tmode;//switch on the selected mode bits.
	RefreshT0CTL();
	break;
	case 1:
	registers::T1CTL&=0xf8;//switch off the first three bits(tmode field) in registers::T0CTL.
	registers::T1CTL|=m_tmode;//switch on the selected mode bits.
	RefreshT1CTL();
	break;
	}
	
	if(m_tmode==3)
	{
	GetDlgItem(IDC_PWMH)->EnableWindow(TRUE);
	GetDlgItem(IDC_PWML)->EnableWindow(TRUE);
	}
	else
	{
	GetDlgItem(IDC_PWMH)->EnableWindow(FALSE);
	GetDlgItem(IDC_PWML)->EnableWindow(FALSE);
	}
	
}


void Timer_input::RefreshT0CTL()
{
		registers::T0CTL&1? m_tctl0.SetBitmap(bit1):m_tctl0.SetBitmap(bit0);	
		registers::T0CTL&2? m_tctl1.SetBitmap(bit1):m_tctl1.SetBitmap(bit0);	
		registers::T0CTL&4? m_tctl2.SetBitmap(bit1):m_tctl2.SetBitmap(bit0);	
		registers::T0CTL&8? m_tctl3.SetBitmap(bit1):m_tctl3.SetBitmap(bit0);	
		registers::T0CTL&16? m_tctl4.SetBitmap(bit1):m_tctl4.SetBitmap(bit0);	
		registers::T0CTL&32? m_tctl5.SetBitmap(bit1):m_tctl5.SetBitmap(bit0);	
		registers::T0CTL&64? m_tctl6.SetBitmap(bit1):m_tctl6.SetBitmap(bit0);	
		registers::T0CTL&128? m_tctl7.SetBitmap(bit1):m_tctl7.SetBitmap(bit0);	
}

void Timer_input::RefreshT1CTL()
{
		registers::T1CTL&1? m_tctl0.SetBitmap(bit1):m_tctl0.SetBitmap(bit0);	
		registers::T1CTL&2? m_tctl1.SetBitmap(bit1):m_tctl1.SetBitmap(bit0);	
		registers::T1CTL&4? m_tctl2.SetBitmap(bit1):m_tctl2.SetBitmap(bit0);	
		registers::T1CTL&8? m_tctl3.SetBitmap(bit1):m_tctl3.SetBitmap(bit0);	
		registers::T1CTL&16? m_tctl4.SetBitmap(bit1):m_tctl4.SetBitmap(bit0);	
		registers::T1CTL&32? m_tctl5.SetBitmap(bit1):m_tctl5.SetBitmap(bit0);	
		registers::T1CTL&64? m_tctl6.SetBitmap(bit1):m_tctl6.SetBitmap(bit0);	
		registers::T1CTL&128? m_tctl7.SetBitmap(bit1):m_tctl7.SetBitmap(bit0);	
}


void Timer_input::RefreshIRQ0ENH()
{
		registers::IRQ0ENH&1? m_irq0enh0.SetBitmap(bit1):m_irq0enh0.SetBitmap(bit0);	
		registers::IRQ0ENH&2? m_irq0enh1.SetBitmap(bit1):m_irq0enh1.SetBitmap(bit0);	
		registers::IRQ0ENH&4? m_irq0enh2.SetBitmap(bit1):m_irq0enh2.SetBitmap(bit0);	
		registers::IRQ0ENH&8? m_irq0enh3.SetBitmap(bit1):m_irq0enh3.SetBitmap(bit0);	
		registers::IRQ0ENH&16? m_irq0enh4.SetBitmap(bit1):m_irq0enh4.SetBitmap(bit0);	
		registers::IRQ0ENH&32? m_irq0enh5.SetBitmap(bit1):m_irq0enh5.SetBitmap(bit0);	
		registers::IRQ0ENH&64? m_irq0enh6.SetBitmap(bit1):m_irq0enh6.SetBitmap(bit0);	
		registers::IRQ0ENH&128? m_irq0enh7.SetBitmap(bit1):m_irq0enh7.SetBitmap(bit0);	
}

void Timer_input::RefreshIRQ0ENL()
{
		registers::IRQ0ENL&1? m_irq0enl0.SetBitmap(bit1):m_irq0enl0.SetBitmap(bit0);	
		registers::IRQ0ENL&2? m_irq0enl1.SetBitmap(bit1):m_irq0enl1.SetBitmap(bit0);	
		registers::IRQ0ENL&4? m_irq0enl2.SetBitmap(bit1):m_irq0enl2.SetBitmap(bit0);	
		registers::IRQ0ENL&8? m_irq0enl3.SetBitmap(bit1):m_irq0enl3.SetBitmap(bit0);	
		registers::IRQ0ENL&16? m_irq0enl4.SetBitmap(bit1):m_irq0enl4.SetBitmap(bit0);	
		registers::IRQ0ENL&32? m_irq0enl5.SetBitmap(bit1):m_irq0enl5.SetBitmap(bit0);	
		registers::IRQ0ENL&64? m_irq0enl6.SetBitmap(bit1):m_irq0enl6.SetBitmap(bit0);	
		registers::IRQ0ENL&128? m_irq0enl7.SetBitmap(bit1):m_irq0enl7.SetBitmap(bit0);	
}


void Timer_input::OnSelchangePrescale() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	switch(tnum)
	{
	case 0:
		registers::T0CTL&=0xc7;
		registers::T0CTL|=m_prescale<<3;
		RefreshT0CTL();	
	break;
	case 1:
		registers::T1CTL&=0xc7;
		registers::T1CTL|=m_prescale<<3;
		RefreshT1CTL();	
	break;

	}

}

void Timer_input::OnSelchangePolarity() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	switch(tnum)
	{
	case 0:
		registers::T0CTL&=0xbf;//switch off the TPOL bit
		registers::T0CTL|=m_tpol<<6;//switch on/off the TPOL bit depending on the user input
		RefreshT0CTL();	
	break;
	case 1:
		registers::T1CTL&=0xbf;//switch off the TPOL bit
		registers::T1CTL|=m_tpol<<6;//switch on/off the TPOL bit depending on the user input
		RefreshT1CTL();	
	break;
	}


}

void Timer_input::OnSelchangeComboInterrupt() 
{
	// TODO: Add your control notification handler code here
		UpdateData(TRUE);
	switch(tnum)
	{
	case 0:
		registers::IRQ0ENH&=0xdf;//switch off the bit 	
		registers::IRQ0ENL&=0xdf;
		if(m_interrupt_opt&1)
		registers::IRQ0ENL|=0x20;//switch on
		if(m_interrupt_opt&2)
		registers::IRQ0ENH|=0x20;//switch on
		break;

	case 1:
		registers::IRQ0ENH&=0xbf;//switch off the bit	
		registers::IRQ0ENL&=0xbf;
		if(m_interrupt_opt&1)
			registers::IRQ0ENL|=0x40;//switch on
		if(m_interrupt_opt&2)
			registers::IRQ0ENH|=0x40;//switch on
		break;
	}	
RefreshIRQ0ENH();
RefreshIRQ0ENL();


}
