// UART.cpp : implementation file
//

#include "stdafx.h"
#include "GPIO Initialization GUI.h"
#include "UART.h"
#include"registers.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define SYSTEM_CLOCK 18432000
/////////////////////////////////////////////////////////////////////////////
// UART dialog


UART::UART(CWnd* pParent /*=NULL*/)
	: CDialog(UART::IDD, pParent)
{
	//{{AFX_DATA_INIT(UART)
	m_baud_rate = 0;
	m_ctse = 0;
	m_mpbt = 0;
	m_mpen = 0;
	m_parity = 0;
	m_reciever = 0;
	m_reciever_interrupt = 0;
	m_transmit = 0;
	m_transmitter_interrupt =0;
	m_mpmd = 0;
	//}}AFX_DATA_INIT
}


void UART::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(UART)
	DDX_Control(pDX, IDC_BIT1, m_BIT1);
	DDX_Control(pDX, IDC_BIT0, m_BIT0);
	DDX_Control(pDX, IDC_UBRH0, m_ubrh0);
	DDX_Control(pDX, IDC_TAB1, m_tab);
	DDX_Control(pDX, IDC_UBRL7, m_ubrl7);
	DDX_Control(pDX, IDC_UBRL6, m_ubrl6);
	DDX_Control(pDX, IDC_UBRL5, m_ubrl5);
	DDX_Control(pDX, IDC_UBRL4, m_ubrl4);
	DDX_Control(pDX, IDC_UBRL3, m_ubrl3);
	DDX_Control(pDX, IDC_UBRL2, m_ubrl2);
	DDX_Control(pDX, IDC_UBRL1, m_ubrl1);
	DDX_Control(pDX, IDC_UBRL0, m_ubrl0);
	DDX_Control(pDX, IDC_UBRH7, m_ubrh7);
	DDX_Control(pDX, IDC_UBRH6, m_ubrh6);
	DDX_Control(pDX, IDC_UBRH5, m_ubrh5);
	DDX_Control(pDX, IDC_UBRH4, m_ubrh4);
	DDX_Control(pDX, IDC_UBRH3, m_ubrh3);
	DDX_Control(pDX, IDC_UBRH2, m_ubrh2);
	DDX_Control(pDX, IDC_UBRH1, m_ubrh1);
	DDX_CBIndex(pDX, IDC_BAUD_RATE, m_baud_rate);
	DDX_CBIndex(pDX, IDC_CTSE, m_ctse);
	DDX_CBIndex(pDX, IDC_MPBT, m_mpbt);
	DDX_CBIndex(pDX, IDC_MPEN, m_mpen);
	DDX_CBIndex(pDX, IDC_PARITY, m_parity);
	DDX_CBIndex(pDX, IDC_RECIEVER, m_reciever);
	DDX_CBIndex(pDX, IDC_RECIEVER_INTERRUPT, m_reciever_interrupt);
	DDX_CBIndex(pDX, IDC_TRANSMIT, m_transmit);
	DDX_CBIndex(pDX, IDC_TRANSMITTER_INTERRUPT, m_transmitter_interrupt);
	DDX_CBIndex(pDX, IDC_MPMD, m_mpmd);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(UART, CDialog)
	//{{AFX_MSG_MAP(UART)
	ON_CBN_SELCHANGE(IDC_BAUD_RATE, OnSelchangeBaudRate)
	ON_CBN_SELCHANGE(IDC_PARITY, OnSelchangeParity)
	ON_CBN_SELCHANGE(IDC_MPEN, OnSelchangeMpen)
	ON_CBN_SELCHANGE(IDC_MPMD, OnSelchangeMpmd)
	ON_CBN_SELCHANGE(IDC_TRANSMIT, OnSelchangeTransmit)
	ON_CBN_SELCHANGE(IDC_TRANSMITTER_INTERRUPT, OnSelchangeTransmitterInterrupt)
	ON_CBN_SELCHANGE(IDC_CTSE, OnSelchangeCtse)
	ON_CBN_SELCHANGE(IDC_RECIEVER, OnSelchangeReciever)
	ON_CBN_SELCHANGE(IDC_RECIEVER_INTERRUPT, OnSelchangeRecieverInterrupt)
	ON_CBN_SELCHANGE(IDC_MPBT, OnSelchangeMpbt)
	ON_CBN_SETFOCUS(IDC_PARITY, OnSetfocusParity)
	ON_CBN_SETFOCUS(IDC_MPEN, OnSetfocusMpen)
	ON_CBN_SETFOCUS(IDC_MPMD, OnSetfocusMpmd)
	ON_CBN_SETFOCUS(IDC_MPBT, OnSetfocusMpbt)
	ON_CBN_SETFOCUS(IDC_TRANSMIT, OnSetfocusTransmit)
	ON_CBN_SETFOCUS(IDC_TRANSMITTER_INTERRUPT, OnSetfocusTransmitterInterrupt)
	ON_CBN_SETFOCUS(IDC_CTSE, OnSetfocusCtse)
	ON_CBN_SETFOCUS(IDC_RECIEVER, OnSetfocusReciever)
	ON_CBN_SETFOCUS(IDC_RECIEVER_INTERRUPT, OnSetfocusRecieverInterrupt)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// UART message handlers



void UART::RefreshBRG()
{
	
		registers::UBRH&1? m_ubrh0.SetBitmap(bit1):m_ubrh0.SetBitmap(bit0);	
		registers::UBRH&2? m_ubrh1.SetBitmap(bit1):m_ubrh1.SetBitmap(bit0);	
		registers::UBRH&4? m_ubrh2.SetBitmap(bit1):m_ubrh2.SetBitmap(bit0);	
		registers::UBRH&8? m_ubrh3.SetBitmap(bit1):m_ubrh3.SetBitmap(bit0);	
		registers::UBRH&16? m_ubrh4.SetBitmap(bit1):m_ubrh4.SetBitmap(bit0);	
		registers::UBRH&32? m_ubrh5.SetBitmap(bit1):m_ubrh5.SetBitmap(bit0);	
		registers::UBRH&64? m_ubrh6.SetBitmap(bit1):m_ubrh6.SetBitmap(bit0);	
		registers::UBRH&128? m_ubrh7.SetBitmap(bit1):m_ubrh7.SetBitmap(bit0);	

		registers::UBRL&1? m_ubrl0.SetBitmap(bit1):m_ubrl0.SetBitmap(bit0);	
		registers::UBRL&2? m_ubrl1.SetBitmap(bit1):m_ubrl1.SetBitmap(bit0);	
		registers::UBRL&4? m_ubrl2.SetBitmap(bit1):m_ubrl2.SetBitmap(bit0);	
		registers::UBRL&8? m_ubrl3.SetBitmap(bit1):m_ubrl3.SetBitmap(bit0);	
		registers::UBRL&16? m_ubrl4.SetBitmap(bit1):m_ubrl4.SetBitmap(bit0);	
		registers::UBRL&32? m_ubrl5.SetBitmap(bit1):m_ubrl5.SetBitmap(bit0);	
		registers::UBRL&64? m_ubrl6.SetBitmap(bit1):m_ubrl6.SetBitmap(bit0);	
		registers::UBRL&128? m_ubrl7.SetBitmap(bit1):m_ubrl7.SetBitmap(bit0);	
}




void UART::OnSelchangeBaudRate() 
{
	// TODO: Add your control notification handler code here
UpdateData(TRUE);
	switch(m_baud_rate)
	{
		case 0: baudrate=300; break;
		case 1: baudrate=1200; break;
		case 2: baudrate=2400; break;
		case 3: baudrate=4800; break;
		case 4: baudrate=9600; break;
		case 5: baudrate=19200; break;
		case 6: baudrate=38400; break;
		case 7: baudrate=57600; break;
		case 8: baudrate=115200; break;	
	}
brg=int(SYSTEM_CLOCK /(16*baudrate));
registers::UBRH=brg>>8;//get the High byte value into UBRH
registers::UBRL=brg&0xff;//get the Low Byte value into UBRL
RefreshBRG();
}
void UART::OnSelchangeParity() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_parity)
	{
		registers::U0CTL0|=0x10;//switch on the parity enable bit
		registers::U0CTL0&=~0x8;//switch off the parity select bit
		if(m_parity&2)
			registers::U0CTL0|=0x8;//switch on the parity select bit to make it Odd parity
	}
	else
	{
		registers::U0CTL0&=~0x10;//switch on the parity enable bit
		registers::U0CTL0&=~0x8;//switch off the parity select bit
	}

	u0ctl->RefreshU0CTL0();
		
}

void UART::OnSelchangeMpen() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	u0ctl->RefreshU0CTL1();
	if(m_mpen)
	{
		registers::U0CTL1|=0x40;
		GetDlgItem(IDC_MPBT)->EnableWindow(TRUE);
		GetDlgItem(IDC_MPMD)->EnableWindow(TRUE);
	}
	else
	{
		registers::U0CTL1&=~0x40;
		GetDlgItem(IDC_MPBT)->EnableWindow(FALSE);
		GetDlgItem(IDC_MPMD)->EnableWindow(FALSE);
		m_mpmd=0;//reset the mode
		m_mpbt=0;//reset the MPBT
		UpdateData(FALSE);
		OnSelchangeMpbt();
		OnSelchangeMpmd();
	}

	u0ctl->RefreshU0CTL1();
}

void UART::OnSelchangeMpmd() 
{
	// TODO: Add your control notification handler code here
UpdateData(TRUE);
registers::U0CTL1&=~0xa0;//switch off mpmd[1] and mpmd[0] bits
switch(m_mpmd)
{
case 1:
	registers::U0CTL1|=0x20;//switch  on the mpmd[0] bit
	break;
case 2:
	registers::U0CTL1|=0x80;//switch on the mpmd[1] bit
	break;
case 3:
	registers::U0CTL1|=0xa0;//switch on the mpmd[1] and mpmd [0] bits
	break;
}

u0ctl->RefreshU0CTL1();

}

void UART::OnSelchangeTransmit() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if(m_transmit)//if transmitter is enabled
	{
		GetDlgItem(IDC_TRANSMITTER_INTERRUPT)->EnableWindow(TRUE);
		GetDlgItem(IDC_CTSE)->EnableWindow(TRUE);
		registers::U0CTL0|=0x80;//Switch On the TEN bit;
	}
	else
	{
		GetDlgItem(IDC_TRANSMITTER_INTERRUPT)->EnableWindow(FALSE);
		GetDlgItem(IDC_CTSE)->EnableWindow(FALSE);
		registers::U0CTL0&=~0x80;//switch off the TEN bit
		m_ctse=0;
		m_transmitter_interrupt=0;
		UpdateData(FALSE);
		OnSelchangeTransmitterInterrupt();
		OnSelchangeCtse();
	}


	u0ctl->RefreshU0CTL0();

}

void UART::OnSelchangeTransmitterInterrupt() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	registers::IRQ0ENH&=~0x8;//switch off the  Transmit Enable High bit 
	registers::IRQ0ENL&=~0x8;//switch off the  Transmit Enable Low bit 	
	switch(m_transmitter_interrupt)
	{
	case 1:
		registers::IRQ0ENL|=0x8;
		break;
	case 2:
		registers::IRQ0ENH|=0x8;
		break;
	case 3:
		registers::IRQ0ENH|=0x8;
		registers::IRQ0ENL|=0x8;
		break;
	}

	irq0->RefreshIRQ0ENH();
	irq0->RefreshIRQ0ENL();

}


void UART::OnSelchangeCtse() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	switch(m_ctse)
	{
	case 0:
		registers::U0CTL0&=~0x20;//switch off the CTSE bit
	break;
	
	case 1:
		registers::U0CTL0|=0x20;//Switch On the CTSE Bit
	break;
	}

	u0ctl->RefreshU0CTL0();

}

void UART::OnSelchangeReciever() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	switch(m_reciever)
	{
	case 0:
		registers::U0CTL0&=~0x40;//switch off the Recieve enable bit
		GetDlgItem(IDC_RECIEVER_INTERRUPT)->EnableWindow(FALSE);
		m_reciever_interrupt=0;
		UpdateData(FALSE);
		OnSelchangeRecieverInterrupt();
	break;
	
	case 1:
		registers::U0CTL0|=0x40;//Switch On the Recieve enable Bit
		GetDlgItem(IDC_RECIEVER_INTERRUPT)->EnableWindow(TRUE);
	break;
	}

	u0ctl->RefreshU0CTL0();

}

void UART::OnSelchangeRecieverInterrupt() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	registers::IRQ0ENH&=~0x10;//switch off the  Recieve Enable High bit 
	registers::IRQ0ENL&=~0x10;//switch off the  Recieve Enable Low bit 	
	switch(m_reciever_interrupt)
	{
	case 1:
		registers::IRQ0ENL|=0x10;
		break;
	case 2:
		registers::IRQ0ENH|=0x10;
		break;
	case 3:
		registers::IRQ0ENH|=0x10;
		registers::IRQ0ENL|=0x10;
		break;
	}

	irq0->RefreshIRQ0ENH();
	irq0->RefreshIRQ0ENL();
	

}

void UART::OnSelchangeMpbt() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	registers::U0CTL1&=~0x10;
	if(m_mpbt)
	registers::U0CTL1|=0x10;
//	RefreshU0CTL1();
	u0ctl->RefreshU0CTL1();
}
void UART::OnDestroy() 
{   
delete u0ctl;
delete irq0;
}

void UART::OnSetfocusParity() 
{
	// TODO: Add your control notification handler code here
	m_tab.SelectTab(0);//select the UART Control Registers Tab
}

void UART::OnSetfocusMpen() 
{
	// TODO: Add your control notification handler code here
	m_tab.SelectTab(0);
}

BOOL UART::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	bit0=m_BIT0.GetBitmap();
	bit1=m_BIT1.GetBitmap();
	RefreshBRG();

	if(m_reciever)//if reciever is enabled
		GetDlgItem(IDC_RECIEVER_INTERRUPT)->EnableWindow(TRUE);
	else
		GetDlgItem(IDC_RECIEVER_INTERRUPT)->EnableWindow(FALSE);

	if(m_transmit)//if transmitter is enabled
	{
		GetDlgItem(IDC_TRANSMITTER_INTERRUPT)->EnableWindow(TRUE);
		GetDlgItem(IDC_CTSE)->EnableWindow(TRUE);
	}
	else
	{
		GetDlgItem(IDC_TRANSMITTER_INTERRUPT)->EnableWindow(FALSE);
		GetDlgItem(IDC_CTSE)->EnableWindow(FALSE);
	}

	if(m_mpen)//if multiprocessor mode is enabled
	{
		GetDlgItem(IDC_MPBT)->EnableWindow(TRUE);
		GetDlgItem(IDC_MPMD)->EnableWindow(TRUE);
	}
	else
	{
		GetDlgItem(IDC_MPBT)->EnableWindow(FALSE);
		GetDlgItem(IDC_MPMD)->EnableWindow(FALSE);
	}

	u0ctl=new U0CTL;
	u0ctl->Create(U0CTL::IDD, &m_tab);
	m_tab.AddTab(u0ctl, "U0CTL Registers", 0);
	u0ctl->m_pTab = &m_tab;
	
	irq0=new IRQ0;
	irq0->Create(IRQ0::IDD, &m_tab);
	m_tab.AddTab(irq0, "IRQ0 Registers", 1);
	irq0->m_pTab = &m_tab;

	m_tab.SetMouseOverColor(RGB(120, 50, 255));
	m_tab.SetNormalColor(RGB(165,145,200));
	m_tab.SelectTab(1);
	irq0->RefreshIRQ0ENH();
	irq0->RefreshIRQ0ENL();
	m_tab.SelectTab(0);
	u0ctl->RefreshU0CTL0();
	u0ctl->RefreshU0CTL1();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void UART::OnSetfocusMpmd() 
{
	// TODO: Add your control notification handler code here
	m_tab.SelectTab(0);
}

void UART::OnSetfocusMpbt() 
{
	// TODO: Add your control notification handler code here
	m_tab.SelectTab(0);	
}

void UART::OnSetfocusTransmit() 
{
	// TODO: Add your control notification handler code here
	m_tab.SelectTab(0);		
}

void UART::OnSetfocusTransmitterInterrupt() 
{
	// TODO: Add your control notification handler code here
	m_tab.SelectTab(1);
}

void UART::OnSetfocusCtse() 
{
	// TODO: Add your control notification handler code here
	m_tab.SelectTab(0);	
}

void UART::OnSetfocusReciever() 
{
	// TODO: Add your control notification handler code here
	m_tab.SelectTab(0);	
}

void UART::OnSetfocusRecieverInterrupt() 
{
	// TODO: Add your control notification handler code here
	m_tab.SelectTab(1);	
}
